# BasicSwap DEX (BSX)

![BasicswapDEX Preview](.github-readme/basicswap_header.jpg)

**[Official Website](https://basicswapdex.com)** | **[News](https://particl.news)** | **[Tutorials](https://academy.particl.io)** | **[Chat]( https://matrix.to/#/#basicswap:matrix.org )**

Table of Contents

* [About](#about)
* [Features](#features)
* [Available Assets](#available-assets)
* [Participate](#participate)
* [Tutorials](#tutorials)
* [License](#license)

## About

The BasicSwap DEX is a privacy-first and decentralized exchange which features cross-chain atomic swaps and a distributed order book.

[BasicSwap](https://academy.particl.io/en/latest/glossary.html#term-BasicSwap) is a cross-chain and privacy-centric DEX (decentralized exchange) that lets you trade cryptocurrencies with no third party involvement. Its distributed order book lets you make or take orders at no cost and trade within a free and open environment without central points of failure.

This DEX protocol was built in direct response to the increasingly invasive demands and data mining practices of today’s cryptocurrency exchanges. It strives to bring more decentralized and more private cryptocurrency trading conditions for all.

BasicSwap is still in beta. This means that, while it already offers most of the vital trading features you’d expect to see on centralized exchanges, it is still in heavy development, and many more features will come about in the near future.

Check out our [roadmap](https://basicswapdex.com/roadmap) to get a better idea of what we've got planned for it!

## Features

* **True cross-chain support** — Swap cryptocurrencies that live on entirely different blockchain environments, like Bitcoin and Monero.
* **Distributed order book** — Make or take limit orders on a completely distributed order book system.
* **No third-party or middleman** — Trade crypto with no intermediaries whatsoever.
* **No trading fees** — Only pay the typical cryptocurrency network fee.
* **Privacy from the ground up** — Every component of BasicSwap is built with a privacy-first commitment.
* **Full Monero support** — Swap Monero with a variety of other cryptocurrencies like Bitcoin or Particl. No wrapped assets or trickery involved.
* **User-friendly interface** — Enjoy all these features within a user-friendly and intuitive interface that handles all the complicated parts for you.

BasicSwap is still in beta. This means that, while it already offers most of the vital trading features you’d expect to see on centralized exchanges, it is still in heavy development, and many more features will come about in the near future.

## Available Assets

BasicSwap is compatible with the following digital assets.

<table>
  <tr>
   <td><strong>Coin Name</strong>
   </td>
   <td><strong>Ticker</strong>
   </td>
  </tr>
  <tr>
   <td>Bitcoin
   </td>
   <td>BTC
   </td>
  </tr>
  <tr>
   <td>Monero
   </td>
   <td>XMR
   </td>
  </tr>
  <tr>
   <td>Dash
   </td>
   <td>DASH
   </td>
  </tr>
  <tr>
   <td>Litecoin
   </td>
   <td>LTC
   </td>
  </tr>
  <tr>
   <td>Firo
   </td>
   <td>FIRO
   </td>
  </tr>
  <tr>
   <td>PIVX
   </td>
   <td>PIVX
   </td>
  </tr>
  <tr>
   <td>Particl
   </td>
   <td>PART
   </td>
  </tr>
</table>

We plan on adding many other cryptocurrencies moving forward, including ETH and its ERC-20 tokens. However, due to the true cross-chain nature of the BasicSwap DEX protocol, each integration has to be done on a case-by-case basis.

If you’d like to add a cryptocurrency to BasicSwap, either [apply for a listing using our listing application form](https://forms.gle/9DsHoHTJVqSiMNHW9), or try coding the integration yourself by referencing how other cryptocurrencies have been added. Follow [this link](https://academy.particl.io/en/latest/basicswap-guides/basicswapguides_apply.html) for more information on how to integrate a coin yourself.

# Participate

### Chats

* **For developers** The chat [#particl-dev:matrix.org](https://app.element.io/#/room/#particl-dev:matrix.org) using [Element](https://element.io) (formerly Riot).
* **For community** The community chat [https://discord.me/particl](https://discord.me/particl) [![Discord](https://img.shields.io/discord/391967609660112925)](https://discord.me/particl).

[![Twitter Follow](https://img.shields.io/twitter/follow/BasicSwapDEX?label=follow%20us&style=social)](http://twitter.com/BasicSwapDEX)
[![Subreddit subscribers](https://img.shields.io/reddit/subreddit-subscribers/particl?style=social)](http://reddit.com/r/particl)

### Documentation, installation

For non-developers curious to explore a new world of commerce, binaries can be downloaded and installed. It is the easiest way to get started. Following the guides on [Particl Academy](https://academy.particl.io), a reference book in straightforward language, is recommended.

* [Download BasicSwapDEX](https://github.com/tecnovert/basicswap/tree/master/doc)

#### Community chat support

* [Discord](https://discord.me/particl) navigate to the #support channel

* [Telegram](https://t.me/particlhelp)

* [Element](https://app.element.io/#/room/#particlhelp:matrix.org)

# Tutorials

You can find a wide variety of tutorials and step-by-step guides about BasicSwap on the [Particl Academy](https://academy.particl.io) or on Particl’s Youtube channel.

If you encounter an issue or try to accomplish something not mentioned in any of the tutorials included in the links above, please join the community chat support channels; you’ll be sure to find help and support from our awesome community and open-source team there!

# License

BasicSwap is released under MIT software license.
